// eff1.cpp: implementation of the eff1 class.
//
//////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <memory.h>
#include <math.h>
#include <stdlib.h>
#include "ptc.h"
#include "eff1.h"

extern unsigned char texture[];
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

eff1::eff1()
{
 strcpy(m_name,"fire");  
 m_framecnt=0;
}

void eff1::genpal(){
 // lock palette data
 int32 *data = palette.lock();
 int j=255;

 while (j>26){
  data[j--]=pack(255,255,255);
 }
 
 while (j>21){
  int p=(j-22)*63;
  data[j--]=pack(p,p,255);
 }
  
 while (j>0){
  data[j--]=pack(0,0,j*12);
 }

 data[0]=pack(0,0,0);
 data[254]=pack(255,0,0);

 // unlock palette
 palette.unlock();
}

void eff1::play(){
double xa,ya,xb,yb,xc,yc,xd,yd,xe,ye;
int x1,x2,x3,x4,x5,y1,y2,y3,y4,y5;
int x6,x7,x8,x9,x10,x11,x12,x13,x14,x15,x16,x17,x18,x19,x20;
int y6,y7,y8,y9,y10,y11,y12,y13,y14,y15,y16,y17,y18,y19,y20;
//myslim ze by slo i int, ale nevim
int pom=500;
float i;
 
 //del screen with blit function
 //Blackscreen();
 pom+=m_framecnt;
 //abych nescital ve floatu
 i=(float)pom;
 xa=160+sin(i/28)*15;
 ya=60+cos(i/26)*10;
 xb=190+sin(i/23)*15;
 yb=40+cos(i/27)*10;
 xc=220+sin(i/25)*15;
 yc=80+cos(i/29)*10;
 xd=250+sin(i/21)*15;
 yd=60+cos(i/24)*10; 
 xe=270+cos(i/22)*30;
 ye=40+cos(i/16)*20;

 x1=(int)(xa+sin(i/25)*18);
 y1=(int)(ya+cos(i/25)*18);
 x2=(int)(xa+sin(i/24)*18);
 y2=(int)(ya+cos(i/26)*18);
 x3=(int)(xa+sin(i/23)*18);
 y3=(int)(ya+cos(i/26.5)*18);
 x4=(int)(xa+sin(i/23)*10);
 y4=(int)(ya+cos(i/20)*10);
 x5=(int)(xa+sin(i/24)*10);
 y5=(int)(ya+cos(i/20.5)*10);
   
 x6=(int)(xb+sin(i/26)*18);
 y6=(int)(yb+cos(i/22)*18); 
 x7=(int)(xb+sin(i/27)*18);
 y7=(int)(yb+cos(i/23.5)*18);
 x8=(int)(xb+sin(i/27.5)*18);
 y8=(int)(yb+cos(i/23)*18);
 x9=(int)(xb+sin(i/26.5)*10);
 y9=(int)(yb+cos(i/25)*10);
 x10=(int)(xb+sin(i/26)*10);
 y10=(int)(yb+cos(i/25.5)*10);

 x11=(int)(xc+sin(i/21)*18);
 y11=(int)(yc+cos(i/21.5)*18);
 x12=(int)(xc+sin(i/22)*18);
 y12=(int)(yc+cos(i/22.5)*18);
 x13=(int)(xc+sin(i/23)*18);
 y13=(int)(yc+cos(i/23.5)*18);
 x14=(int)(xc+sin(i/29)*10);
 y14=(int)(yc+cos(i/28.5)*10);
 x15=(int)(xc+sin(i/29.5)*10);
 y15=(int)(yc+cos(i/28.5)*10);

 x16=(int)(xe+sin(i/21)*18);
 y16=(int)(ye+cos(i/21.5)*18);
 x17=(int)(xe+sin(i/22)*18);
 y17=(int)(ye+cos(i/22.5)*18);
 x18=(int)(xe+sin(i/23)*18);
 y18=(int)(ye+cos(i/23.5)*18);
 x19=(int)(xe+sin(i/29)*10);
 y19=(int)(ye+cos(i/28.5)*10);
 x20=(int)(xe+sin(i/29.5)*10);
 y20=(int)(ye+cos(i/28.5)*10);
 
 putplot(x1,y1);
 putplot(x2,y2);
 putplot(x3,y3);
 putplot(x4,y4);
 putplot(x5,y5); 

 putplot(x6,y6); 
 putplot(x7,y7);
 putplot(x8,y8);
 putplot(x9,y9);
 putplot(x10,y10);
 putplot(x11,y11);
 putplot(x12,y12);
 putplot(x13,y13);
 putplot(x14,y14);
 putplot(x15,y15);
 if (m_framecnt>263 && m_framecnt<800) printspr(6,5,68,19,160,25,254,mp_pixels);
 if (m_framecnt>528 && m_framecnt<800) printspr(71,6,175,20,160,45,254,mp_pixels);
 if (m_framecnt>650 && m_framecnt<800) printspr(5,22,163,35,160,65,254,mp_pixels);
 if (m_framecnt>800 && m_framecnt<1300) printspr(177,6,290,20,120,70,254,mp_pixels);
 newgr();
 scrollup2();
 memcpy(mp_pixels+320*160,buffer+320*160,40*320);
 memcpy(lbuffer+320*160,buffer+320*160,42*320);
 m_framecnt++;
}


void eff1::newgr(void)
{
 int i=0;
 int z;
 int poziceb;
 for(i;i<320;i++)
  {
   buffer[i+320*200]=(rand()%50 + 1);
   buffer[i+320*201]=(rand()%50 + 1);
  }
 poziceb=320*201;
 for(i=0;i<21;i++);
  {
   z=(rand() %320 );
   poziceb+=z;
   buffer[poziceb]=55;
   buffer[poziceb+320]=55;
   buffer[poziceb-320]=55;
   buffer[poziceb+1]=55;
   buffer[poziceb-1]=55;
   buffer[poziceb+319]=55;
   buffer[poziceb-319]=55;
   buffer[poziceb+321]=55;
   buffer[poziceb-321]=55;
   }
}

void eff1::putplot(int x, int y)
{
 unsigned int mistocil;
 int yloop,xloop;
 unsigned int mistozdroj=0;

 mistocil=x+y*m_width;         //misto x,y v buferu                   
 for(yloop=59;yloop>(-1);yloop--)
  {mistocil+=240;            //posun na dalsi radek (320-80)
   for(xloop=79;xloop>(-1);xloop--)
    {
	  mp_pixels[mistocil++]=texture[mistozdroj++]+mp_pixels[mistocil];
     /*mistocil++;      // vykresli na misto v bufferu bod z textury z
      mistozdroj++*/;   // puvodniho bufferu 
     }
   } 
} 

void eff1::scrollup2(void){
int opak=40*320;
int pozicel=161*320;
int poziceb=160*320;
int prumerl;
 for(opak;opak--;)
 {
  prumerl=(lbuffer[pozicel+320]+lbuffer[pozicel]+
          lbuffer[pozicel-1]+lbuffer[pozicel+1])>>2;
  pozicel++;
  if ((prumerl!=0) & (poziceb<(320*(160+20)))) prumerl-=1;
  buffer[poziceb++]=prumerl;
  }
}

eff1::~eff1()
{

}
