// eff.h: interface for the eff class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EFF_H__192ABEA4_B270_11D4_B55F_00C06C431669__INCLUDED_)
#define AFX_EFF_H__192ABEA4_B270_11D4_B55F_00C06C431669__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class eff  
{
public:
	eff();
	virtual void genpal();
    Palette* getpal();
    virtual void play();
	void setsurface(Surface* surface);
    int ESCkey(Console &ref_cons);
    void printspr(int s1x,int s1y, int s2x,int s2y,
              int dx,int dy,int col,char8* where);
	void vPixScr(int X,int Y,char Color,char *where);
    void DrawLine(int X1,int Y1,int X2,int Y2,char Color,char *Video);
    void gourhline(int x1,int x2, int c1,int c2,
               int y, char *where);
	inline int32 pack(int32 r,int32 g,int32 b) 
	{ // pack color integer
     return (r<<16) | (g<<8) | b; 
	}
 
	virtual ~eff();
     
protected:
	char   m_name[20]; 
	Surface* mp_surface;
	int m_width;
	int m_height;
    int m_framecnt;
	char8* mp_pixels;
	Palette palette;
};


#endif // !defined(AFX_EFF_H__192ABEA4_B270_11D4_B55F_00C06C431669__INCLUDED_)
